
use builtin;
use str;

set edit:completion:arg-completer[lic] = {|@words|
    fn spaces {|n|
        builtin:repeat $n ' ' | str:join ''
    }
    fn cand {|text desc|
        edit:complex-candidate $text &display=$text' '(spaces (- 14 (wcswidth $text)))$desc
    }
    var command = 'lic'
    for word $words[1..-1] {
        if (str:has-prefix $word '-') {
            break
        }
        set command = $command';'$word
    }
    var completions = [
        &'lic'= {
            cand -c 'c'
            cand --config 'config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
            cand -V 'Print version'
            cand --version 'Print version'
            cand gen 'Generate a license file'
            cand unapply 'Remove license headers in source files'
            cand apply 'Apply license headers to source files'
            cand init 'Initialize a default configuration file'
            cand help 'Print this message or the help of the given subcommand(s)'
        }
        &'lic;gen'= {
            cand -a 'Author names and emails (In the format NAME:EMAIL; entries seperated by a comma. Email optional)'
            cand --authors 'Author names and emails (In the format NAME:EMAIL; entries seperated by a comma. Email optional)'
            cand -d 'Date for the license copyright notice (defaults to the current year)'
            cand --date 'Date for the license copyright notice (defaults to the current year)'
            cand --multiple 'Enable support for multiple licenses in the same project (Default is replace)'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'lic;unapply'= {
            cand -e 'Regex pattern for files/directories to exclude. Applied during directory traversal'
            cand --exclude 'Regex pattern for files/directories to exclude. Applied during directory traversal'
            cand -D 'Run without modification. See what would be changed'
            cand --dry-run 'Run without modification. See what would be changed'
            cand -A 'Do not respect the git_ignore file (If present in directory) and other pattern defaults'
            cand --all 'Do not respect the git_ignore file (If present in directory) and other pattern defaults'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'lic;apply'= {
            cand -a 'Author names and emails (In the format NAME:EMAIL; entries seperated by a comma. Email optional)'
            cand --authors 'Author names and emails (In the format NAME:EMAIL; entries seperated by a comma. Email optional)'
            cand -d 'Date for the license copyright notice (defaults to the current year)'
            cand --date 'Date for the license copyright notice (defaults to the current year)'
            cand -e 'Regex pattern for files/directories to exclude. Applied during directory traversal'
            cand --exclude 'Regex pattern for files/directories to exclude. Applied during directory traversal'
            cand --multiple 'Enable support for multiple licenses in the same project (Default is replace)'
            cand -A 'Do not respect the git_ignore file (If present in directory) and other pattern defaults'
            cand --all 'Do not respect the git_ignore file (If present in directory) and other pattern defaults'
            cand -D 'Run without modification. See what would be changed'
            cand --dry-run 'Run without modification. See what would be changed'
            cand --prefer-block 'When applying headers, which kind of comment token the user *wants* Completely possible line or block doesn''t exist, in which case it falls back to the other'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'lic;init'= {
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'lic;help'= {
            cand gen 'Generate a license file'
            cand unapply 'Remove license headers in source files'
            cand apply 'Apply license headers to source files'
            cand init 'Initialize a default configuration file'
            cand help 'Print this message or the help of the given subcommand(s)'
        }
        &'lic;help;gen'= {
        }
        &'lic;help;unapply'= {
        }
        &'lic;help;apply'= {
        }
        &'lic;help;init'= {
        }
        &'lic;help;help'= {
        }
    ]
    $completions[$command]
}
